/* A RapidNet application. Generated by RapidNet compiler. */

#ifndef EPIDEMIC_H
#define EPIDEMIC_H

#include <string>
#include <iostream>
#include "ns3/ptr.h"
#include "ns3/event-id.h"
#include "ns3/ipv4-address.h"
#include "ns3/rapidnet-header.h"
#include "ns3/relation-base.h"
#include "ns3/database.h"
#include "ns3/discovery-epidemic.h"
#include "ns3/aggregator.h"
#include "ns3/aggwrap.h"

using namespace std;
using namespace ns3;
using namespace ns3::rapidnet::discoveryepidemic;

namespace ns3 {

class Socket;
class Packet;

namespace rapidnet {
namespace epidemic {

class Epidemic : public DiscoveryEpidemic
{
public:
  static const string EBITVECTORREPLY;
  static const string EBITVECTORREQUEST;
  static const string ELINKADD;
  static const string ELINKDISCOVERYADD;
  static const string ELINKDISCOVERYDEL;
  static const string EMESSAGE;
  static const string EMESSAGEBEGIN;
  static const string EMESSAGEDEL;
  static const string EMESSAGEEND;
  static const string EMESSAGEINJECT;
  static const string EMESSAGEINJECTORIGINAL;
  static const string EMESSAGELOC;
  static const string EMESSAGENEW;
  static const string LINK;
  static const string PERIODIC;
  static const string R11_ECAPERIODIC;
  static const string R29_ECAPERIODIC;
  static const string TLINK;
  static const string TMESSAGE;
  static const string TSUMMARYVEC;

  static TypeId GetTypeId (void);

  Epidemic ();

  virtual ~Epidemic ();

protected:

  virtual void DoDispose (void);

  virtual void StartApplication (void);

  virtual void StopApplication (void);

  virtual void InitDatabase (void);

  virtual void DemuxRecv (Ptr<Tuple> tuple);

  virtual void R01_eca (Ptr<Tuple> eLinkDiscoveryAdd);

  virtual void R02_eca (Ptr<Tuple> eLinkDiscoveryDel);

  virtual void R03Eca0Ins (Ptr<Tuple> tLink);

  virtual void R04_eca (Ptr<Tuple> eMessageInject);

  virtual void R05Eca0Ins (Ptr<Tuple> tMessage);

  virtual void R11_ecaperiodic ();

  virtual void R11_eca (Ptr<Tuple> r11_ecaperiodic);

  virtual void R12_eca (Ptr<Tuple> eLinkAdd);

  virtual void R13_eca (Ptr<Tuple> eBitVectorRequest);

  virtual void R14_eca (Ptr<Tuple> eBitVectorReply);

  virtual void R21_eca (Ptr<Tuple> eMessageInjectOriginal);

  virtual void R22_eca (Ptr<Tuple> eMessageInject);

  virtual void R23_eca (Ptr<Tuple> eMessageInject);

  virtual void R24Eca0Ins (Ptr<Tuple> tMessage);

  virtual void R25_eca (Ptr<Tuple> eMessageNew);

  virtual void R26_eca (Ptr<Tuple> eMessage);

  virtual void R27_eca (Ptr<Tuple> eMessageLoc);

  virtual void R28_eca (Ptr<Tuple> eMessageLoc);

  virtual void R29_ecaperiodic ();

  virtual void R29_eca (Ptr<Tuple> r29_ecaperiodic);

  virtual void R2A_eca (Ptr<Tuple> eMessageDel);

  virtual void R2B_eca (Ptr<Tuple> eMessageDel);

  uint32_t m_count_r11_ecaperiodic;
  EventId m_event_r11_ecaperiodic;
  EventId m_event_r29_ecaperiodic;
};

} // namespace epidemic
} // namespace rapidnet
} // namespace ns3

#endif // EPIDEMIC_H
